﻿/***********************************************************************
 * Name: 
 * Description: 
 * 
 * Created time: 2008-5-10 2:13:16 Author: GoCool E-mail: volnet@tom.com
 * Copyright reserved by GoCool
 ***********************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;

namespace ContainerManager
{
    public class ContainerManager
    {
        public void CacheControls(object storage, string key, ControlCollection controls)
        {
            HistoryStoreProxy<Control>.Storage = ICollectionHistoryFactory<Control>.CreateInstance(storage);
            IList<Control> controlHistory = new List<Control>();

            foreach (Control c in controls)
            {
                controlHistory.Add(c);
            }

            HistoryStoreProxy<Control>.Add(key, controlHistory);
        }

        /// <summary>
        /// 追加控件到控件集合尾部
        /// </summary>
        /// <param name="storage">存储空间，可以是一个缓存也可以是一个数据库表，其必须在ICollectionHistoryFactory中有所定义。</param>
        /// <param name="key"></param>
        /// <param name="controls"></param>
        /// <param name="addItem"></param>
        public void AppendControl(object storage, string key, ControlCollection controls, Control addItem)
        {
            HistoryStoreProxy<Control>.Storage = ICollectionHistoryFactory<Control>.CreateInstance(storage);
            IList<Control> controlHistory = HistoryStoreProxy<Control>.History(key);

            controlHistory.Add(addItem);
            foreach (Control c in controlHistory)
            {
                controls.Add(c);
            }

            HistoryStoreProxy<Control>.Add(key, controlHistory);
        }

        /// <summary>
        /// 从storage中将索引为key的所有控件重新载入到controlCollection中
        /// </summary>
        /// <param name="storage"></param>
        /// <param name="key"></param>
        /// <param name="controls"></param>
        public void ReloadControls(object storage, string key, ControlCollection controls)
        {
            HistoryStoreProxy<Control>.Storage = ICollectionHistoryFactory<Control>.CreateInstance(storage);

            IList<Control> controlHistory = HistoryStoreProxy<Control>.History(key);

            foreach (Control c in controlHistory)
            {
                controls.Add(c);
            }
        }

        public void Remove(object storage, string key)
        {
            ICollectionHistoryFactory<Control>.CreateInstance(storage).Remove(key);
        }
    }
}
