﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ContainerManager
{
    public interface ICollectionHistroy<U>
    {
        /// <summary>
        /// 存储空间，可以是一个缓存也可以是一个数据库表，其必须在ICollectionHistoryFactory中有所定义。
        /// </summary>
        object Storage { set; }

        /// <summary>
        /// 向存储空间中追加元素
        /// </summary>
        /// <param name="key"></param>
        /// <param name="u"></param>
        void Add(string key, IList<U> u);

        /// <summary>
        /// 存储空间中属于该key的所有项，该项的顺序规则由继承类自行定义。
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        IList<U> Histroy(string key);

        /// <summary>
        ///  是否存在键值为key的项
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        bool ContainsKey(string key);

        /// <summary>
        /// 移除键值为key的项
        /// </summary>
        /// <param name="key"></param>
        /// <returns></returns>
        void Remove(string key);
    }
}
