﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Collections.Generic;

namespace ContainerManager
{
    public class SessionHistoryManager<U>: StoreHistroyManager<U>
    {
        public SessionHistoryManager() { }
        public SessionHistoryManager(object storage)
        {
            _storage = storage;
        }

        #region ICollectionHistroy<U> 成员

        public override void Add(string key, IList<U> u)
        {
            (_storage as System.Web.SessionState.HttpSessionState).Add(key, u);
        }

        public override IList<U> Histroy(string key)
        {
            System.Web.SessionState.HttpSessionState cache = _storage as System.Web.SessionState.HttpSessionState;
            return cache[key] == null ? new List<U>() : cache[key] as List<U>;
        }

        public override bool ContainsKey(string key)
        { 
            System.Web.SessionState.HttpSessionState cache = _storage as System.Web.SessionState.HttpSessionState;
            return cache[key] != null;
        }

        public override void Remove(string key)
        {
            (_storage as System.Web.SessionState.HttpSessionState).Remove(key);
        }

        #endregion
    }
}
