﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Xml.Linq;
using System.Collections.Generic;

namespace ContainerManager
{
    public class WebCacheHistroyManager<U> : StoreHistroyManager<U>
    {
        public WebCacheHistroyManager() { }
        public WebCacheHistroyManager(object cache)
        {
            _storage = cache;
        }
        public override void Add(string key, IList<U> u)
        {
            (_storage as System.Web.Caching.Cache).Add(key, u, null, DateTime.MaxValue, TimeSpan.Zero, System.Web.Caching.CacheItemPriority.Default, null);
        }

        public override IList<U> Histroy(string key)
        {
            System.Web.Caching.Cache cache = _storage as System.Web.Caching.Cache;
            return cache[key] == null ? new List<U>() : cache[key] as List<U>;
        }

        public override bool ContainsKey(string key)
        {
            return (_storage as System.Web.Caching.Cache)[key] != null;
        }

        public override void Remove(string key)
        {
            (_storage as System.Web.Caching.Cache).Remove(key);
        }
    }
}
